# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus_client.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.i_base_resource import IBaseResource  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.i_id_type import IIdType  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.identifier import Identifier  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.uri_type import UriType  # noqa: F401,E501


class Reference(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'resource': 'IBaseResource',
        'reference': 'str',
        'type': 'str',
        'identifier': 'Identifier',
        'display': 'str',
        'display_element': 'StringType',
        'type_element': 'UriType',
        'reference_element_': 'StringType',
        'reference_element': 'IIdType',
        'empty': 'bool',
        'extension_first_rep': 'Extension',
        'id_element': 'StringType',
        'id_base': 'str',
        'primitive': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'resource': 'resource',
        'reference': 'reference',
        'type': 'type',
        'identifier': 'identifier',
        'display': 'display',
        'display_element': 'displayElement',
        'type_element': 'typeElement',
        'reference_element_': 'referenceElement_',
        'reference_element': 'referenceElement',
        'empty': 'empty',
        'extension_first_rep': 'extensionFirstRep',
        'id_element': 'idElement',
        'id_base': 'idBase',
        'primitive': 'primitive',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, resource=None, reference=None, type=None, identifier=None, display=None, display_element=None, type_element=None, reference_element_=None, reference_element=None, empty=None, extension_first_rep=None, id_element=None, id_base=None, primitive=None, boolean_primitive=None, date_time=None):  # noqa: E501
        """Reference - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._resource = None
        self._reference = None
        self._type = None
        self._identifier = None
        self._display = None
        self._display_element = None
        self._type_element = None
        self._reference_element_ = None
        self._reference_element = None
        self._empty = None
        self._extension_first_rep = None
        self._id_element = None
        self._id_base = None
        self._primitive = None
        self._boolean_primitive = None
        self._date_time = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if resource is not None:
            self.resource = resource
        if reference is not None:
            self.reference = reference
        if type is not None:
            self.type = type
        if identifier is not None:
            self.identifier = identifier
        if display is not None:
            self.display = display
        if display_element is not None:
            self.display_element = display_element
        if type_element is not None:
            self.type_element = type_element
        if reference_element_ is not None:
            self.reference_element_ = reference_element_
        if reference_element is not None:
            self.reference_element = reference_element
        if empty is not None:
            self.empty = empty
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_element is not None:
            self.id_element = id_element
        if id_base is not None:
            self.id_base = id_base
        if primitive is not None:
            self.primitive = primitive
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this Reference.  # noqa: E501


        :return: The format_comments_pre of this Reference.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this Reference.


        :param format_comments_pre: The format_comments_pre of this Reference.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this Reference.  # noqa: E501


        :return: The format_comments_post of this Reference.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this Reference.


        :param format_comments_post: The format_comments_post of this Reference.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this Reference.  # noqa: E501


        :return: The id of this Reference.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Reference.


        :param id: The id of this Reference.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this Reference.  # noqa: E501


        :return: The extension of this Reference.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this Reference.


        :param extension: The extension of this Reference.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this Reference.  # noqa: E501


        :return: The disallow_extensions of this Reference.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this Reference.


        :param disallow_extensions: The disallow_extensions of this Reference.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def resource(self):
        """Gets the resource of this Reference.  # noqa: E501


        :return: The resource of this Reference.  # noqa: E501
        :rtype: IBaseResource
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this Reference.


        :param resource: The resource of this Reference.  # noqa: E501
        :type: IBaseResource
        """

        self._resource = resource

    @property
    def reference(self):
        """Gets the reference of this Reference.  # noqa: E501


        :return: The reference of this Reference.  # noqa: E501
        :rtype: str
        """
        return self._reference

    @reference.setter
    def reference(self, reference):
        """Sets the reference of this Reference.


        :param reference: The reference of this Reference.  # noqa: E501
        :type: str
        """

        self._reference = reference

    @property
    def type(self):
        """Gets the type of this Reference.  # noqa: E501


        :return: The type of this Reference.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Reference.


        :param type: The type of this Reference.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def identifier(self):
        """Gets the identifier of this Reference.  # noqa: E501


        :return: The identifier of this Reference.  # noqa: E501
        :rtype: Identifier
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """Sets the identifier of this Reference.


        :param identifier: The identifier of this Reference.  # noqa: E501
        :type: Identifier
        """

        self._identifier = identifier

    @property
    def display(self):
        """Gets the display of this Reference.  # noqa: E501


        :return: The display of this Reference.  # noqa: E501
        :rtype: str
        """
        return self._display

    @display.setter
    def display(self, display):
        """Sets the display of this Reference.


        :param display: The display of this Reference.  # noqa: E501
        :type: str
        """

        self._display = display

    @property
    def display_element(self):
        """Gets the display_element of this Reference.  # noqa: E501


        :return: The display_element of this Reference.  # noqa: E501
        :rtype: StringType
        """
        return self._display_element

    @display_element.setter
    def display_element(self, display_element):
        """Sets the display_element of this Reference.


        :param display_element: The display_element of this Reference.  # noqa: E501
        :type: StringType
        """

        self._display_element = display_element

    @property
    def type_element(self):
        """Gets the type_element of this Reference.  # noqa: E501


        :return: The type_element of this Reference.  # noqa: E501
        :rtype: UriType
        """
        return self._type_element

    @type_element.setter
    def type_element(self, type_element):
        """Sets the type_element of this Reference.


        :param type_element: The type_element of this Reference.  # noqa: E501
        :type: UriType
        """

        self._type_element = type_element

    @property
    def reference_element_(self):
        """Gets the reference_element_ of this Reference.  # noqa: E501


        :return: The reference_element_ of this Reference.  # noqa: E501
        :rtype: StringType
        """
        return self._reference_element_

    @reference_element_.setter
    def reference_element_(self, reference_element_):
        """Sets the reference_element_ of this Reference.


        :param reference_element_: The reference_element_ of this Reference.  # noqa: E501
        :type: StringType
        """

        self._reference_element_ = reference_element_

    @property
    def reference_element(self):
        """Gets the reference_element of this Reference.  # noqa: E501


        :return: The reference_element of this Reference.  # noqa: E501
        :rtype: IIdType
        """
        return self._reference_element

    @reference_element.setter
    def reference_element(self, reference_element):
        """Sets the reference_element of this Reference.


        :param reference_element: The reference_element of this Reference.  # noqa: E501
        :type: IIdType
        """

        self._reference_element = reference_element

    @property
    def empty(self):
        """Gets the empty of this Reference.  # noqa: E501


        :return: The empty of this Reference.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this Reference.


        :param empty: The empty of this Reference.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this Reference.  # noqa: E501


        :return: The extension_first_rep of this Reference.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this Reference.


        :param extension_first_rep: The extension_first_rep of this Reference.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_element(self):
        """Gets the id_element of this Reference.  # noqa: E501


        :return: The id_element of this Reference.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this Reference.


        :param id_element: The id_element of this Reference.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def id_base(self):
        """Gets the id_base of this Reference.  # noqa: E501


        :return: The id_base of this Reference.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this Reference.


        :param id_base: The id_base of this Reference.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def primitive(self):
        """Gets the primitive of this Reference.  # noqa: E501


        :return: The primitive of this Reference.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this Reference.


        :param primitive: The primitive of this Reference.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this Reference.  # noqa: E501


        :return: The boolean_primitive of this Reference.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this Reference.


        :param boolean_primitive: The boolean_primitive of this Reference.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this Reference.  # noqa: E501


        :return: The date_time of this Reference.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this Reference.


        :param date_time: The date_time of this Reference.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Reference):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
